Summary: packet-sniffer/logger
Name: snort
Version: 1.9.1
Release: rh8_3
Copyright: GPL
Group: Applications/Internet
Source0: http://www.snort.org/Files/%{name}-%{version}.tar.gz
Source1: snort-stat
Source2: snortlog
Source4: snortd
Patch0: snort.configure.patch
Url: http://www.snort.org
BuildRoot: /var/tmp/%{name}-root
Prefix: /usr
Packager: Ralf Spenneberg <ralf@spenneberg.de> - OpenSource Security

%description
Snort is a libpcap-based packet sniffer/logger which 
can be used as a lightweight network intrusion detection system. 
It features rules based logging and can perform protocol analysis, 
content searching/matching and can be used to detect a variety of 
attacks and probes, such as buffer overflows, stealth port scans, 
CGI attacks, SMB probes, OS fingerprinting attempts, and much more. 
Snort has a real-time alerting capabilty, with alerts being sent to syslog, 
a seperate "alert" file, or as a WinPopup message via Samba's smbclient
This package has been compiled with Postgresql and Mysql Support.
Furthermore smbalerts, snmp, flexresponse and openssl have been turned on.
Keep in mind though, that all these plugins eat performance!

%prep
%setup -q 
#%patch0 -p1 -b configure.in

%build
#CFLAGS="$RPM_OPT_FLAGS" \
autoconf
./configure --prefix=/usr --bindir=/usr/sbin --sysconfdir=/etc/snort --enable-flexresp --enable-smbalerts --with-postgresql --with-mysql --with-snmp --with-openssl  
aclocal
automake
make

%install
if [ "$RPM_BUILD_ROOT" = "/var/tmp/snort-root" ]; then
	rm -rf $RPM_BUILD_ROOT
        mkdir -p $RPM_BUILD_ROOT/usr/share/man/man8
	mkdir -p $RPM_BUILD_ROOT/usr/bin
	mkdir -p $RPM_BUILD_ROOT/usr/sbin
	mkdir -p $RPM_BUILD_ROOT/usr/doc
	mkdir -p $RPM_BUILD_ROOT/etc/snort
	mkdir -p $RPM_BUILD_ROOT/var/log/snort/archive
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
        cp snort.8 $RPM_BUILD_ROOT/usr/share/man/man8
	make prefix=$RPM_BUILD_ROOT/usr bindir=$RPM_BUILD_ROOT/usr/sbin sysconfdir=$RPM_BUILD_ROOT/etc/snort install
	cd rules
	install \
attack-responses.rules \
backdoor.rules \
bad-traffic.rules \
chat.rules \
ddos.rules \
deleted.rules \
dns.rules \
dos.rules \
experimental.rules \
exploit.rules \
finger.rules \
ftp.rules \
icmp-info.rules \
icmp.rules \
info.rules \
local.rules \
misc.rules \
multimedia.rules \
mysql.rules \
netbios.rules \
nntp.rules \
oracle.rules \
other-ids.rules \
p2p.rules \
policy.rules \
pop2.rules \
pop3.rules \
porn.rules \
rpc.rules \
rservices.rules \
scan.rules \
shellcode.rules \
smtp.rules \
snmp.rules \
sql.rules \
telnet.rules \
tftp.rules \
virus.rules \
web-attacks.rules \
web-cgi.rules \
web-client.rules \
web-coldfusion.rules \
web-frontpage.rules \
web-iis.rules \
web-misc.rules \
web-php.rules \
x11.rules \
	 $RPM_BUILD_ROOT/etc/snort
	cd ..
	install etc/* $RPM_BUILD_ROOT/etc/snort
	install %{SOURCE1} $RPM_BUILD_ROOT/usr/bin
	install %{SOURCE2} $RPM_BUILD_ROOT/usr/bin
	install %{SOURCE4} $RPM_BUILD_ROOT/etc/rc.d/init.d
	install contrib/create_mysql $RPM_BUILD_ROOT/etc/snort
	install contrib/create_oracle.sql $RPM_BUILD_ROOT/etc/snort
	install contrib/create_postgresql $RPM_BUILD_ROOT/etc/snort
else
	echo Invalid Build root
	exit 1
fi

%clean
if [ "$RPM_BUILD_ROOT" = "/var/tmp/snort-root" ]; then
	rm -rf $RPM_BUILD_ROOT
else
	echo Invalid Build root
	exit 1
fi

%pre
grep snort /etc/passwd || useradd -M -r -d /var/log/snort -s /bin/false -c "Snort" snort 2> /dev/null || true

						
%post
#don't do all this stuff if we are upgrading
if [ $1 = 1 ] ; then
useradd -M -r -d /var/log/snort -s /bin/false -c "Snort" snort 2> /dev/null || true
groupadd -r snort 2> /dev/null || true
/sbin/chkconfig --add snortd
fi
#this only works on redhat ;/
# First backup the stock snort.conf file, then extract DNS servers and add them to our
# new snort.conf file
 
#mv /etc/snort/snort.conf /etc/snort/snort.conf.pristine
#perl -e  'open(f,"/etc/resolv.conf");
#         while(<f>){if (/nameserver(.*)/) {$dns=$1;$dns=~s/[ ]+//g;
#	 $dns.="/32,"; push(@dns,$dns);}} close(f);
#	 $dns[$#dns]=~s/,$//g;
#        open(f,">/etc/snort/snort.conf");
#         print f "var DNS_SERVERS ";
#         foreach (@dns) {print f "$_";}
#         print f "\n";
#	 close(f);'

#add the rest of the stuff and concatenate

#cat /etc/snort/snort.conf.pristine | \
# sed -e 's/^var HOME_NET any$/#var HOME_NET any/' \
# -e 's/^var DNS_SERVERS \$HOME_NET$/#var DNS_SERVERS \$HOME_NET/' \
# -e 's/^# var HOME_NET \$eth0_ADDRESS$/var HOME_NET \$eth0_ADDRESS/' \
# >> /etc/snort/snort.conf

chown snort /var/log/snort
chown snort /etc/snort/*

%preun
/etc/rc.d/init.d/snortd stop
if [ $1 = 0 ] ; then
/sbin/chkconfig --del snortd
fi

%postun
#only if we are removing, not upgrading..
if [ $1 = 0 ] ; then
userdel snort 2> /dev/null || true
groupdel snort 2> /dev/null || true
fi

%files
%defattr(-,snort,root)
%doc COPYING ChangeLog LICENSE doc/*
%doc $RPM_SOURCE_DIR/snort.conf.dist
/usr/share/man/man8
%attr(755,snort,root)       /usr/sbin/*
%attr(755,snort,root) 	   /usr/bin/*
%attr(750,snort,wheel)  %dir /var/log/snort
%attr(750,snort,wheel)  %dir /var/log/snort/archive
%attr(640,snort,wheel) %config(noreplace)     /etc/snort/*
%attr(750,snort,root)   /etc/rc.d/init.d/snortd

%changelog
* Wed Apr 09 2003 Ralf Spenneberg <ralf@spenneberg.de>
- Added missing maps and rules

* Tue Mar 04 2003 Ralf Spenneberg <ralf@spenneberg.de>
- Moved to snort 1.9.1 because of a security hole in the RPC decode

* Tue Oct 22 2002 Ralf Spenneberg <ralf@spenneberg.de>
- Moved to snort 1.9
- Built on RedHat 8.0

* Mon Apr 05 2002 Ralf Spenneberg <ralf@spenneberg.de>
- Moved to snort 1.8.4

* Mon Aug 13 2001 Ralf Spenneberg <ralf@spenneberg.de>
- Added Mysql/Postgresql Support

* Thu Jul 12 2001 Marion Bates <mbates@ists.dartmouth.edu>
- Updated source to 1.8p1. 
- Fixed syntax problem (bad square brackets) with DNS servers in snort.conf.
- Changed process to use and slightly alter stock snort.conf file, instead of creating from scratch.

* Wed Jul 11 2001 William Stearns <wstearns@pobox.com>
- Updated source to 1.8-RELEASE, will later shoot Marty for using -RELEASE.
- Use new X-rules config files instead of old X-lib files

* Sat Jan 06 2001 Wim Vandersmissen <wim@bofh.be>
- Updated to version 1.7
- Some minor changes to snort.conf (uses default ruleset instead of vision rules)

* Tue Jul 25 2000 Wim Vandersmissen <wim@bofh.st>
- Added some checks to find out if we're upgrading or removing the package

* Sat Jul 22 2000 Wim Vandersmissen <wim@bofh.st>
- Updated to version 1.6.3
- Fixed the user/group stuff (moved to %post)
- Added userdel/groupdel to %postun
- Automagically adds the right IP, nameservers to /etc/snort/rules.base

* Sat Jul 08 2000 Dave Wreski <dave@linuxsecurity.com>
- Updated to version 1.6.2
- Removed references to xntpd
- Fixed minor problems with snortd init script

* Fri Jul 07 2000 Dave Wreski <dave@linuxsecurity.com>
- Updated to version 1.6.1
- Added user/group snort

* Sat Jun 10 2000 Dave Wreski <dave@linuxsecurity.com>
- Added snort init.d script (snortd)
- Added Dave Dittrich's snort rules header file (ruiles.base)
- Added Dave Dittrich's wget rules fetch script (check-snort)
- Fixed permissions on /var/log/snort
- Created /var/log/snort/archive for archival of snort logs
- Added post/preun to add/remove snortd to/from rc?.d directories
- Defined configuration files as %config

* Tue Mar 28 2000 William Stearns <wstearns@pobox.com>
- Quick update to 1.6.
- Sanity checks before doing rm-rf in install and clean

* Fri Dec 10 1999 Henri Gomez <gomez@slib.fr>
- 1.5-0 Initial RPM release
